# -*- coding: utf-8 -*-
try:
	from urllib2 import urlopen, Request, build_opener, HTTPRedirectHandler
except ImportError:
	from urllib.request import urlopen, Request, build_opener, HTTPRedirectHandler
try:
	from urlparse import urlparse, urlunparse, urljoin
except ImportError:
	from urllib.parse import urlparse, urlunparse, urljoin
import sys, re
from bs4 import BeautifulSoup

def httpget(url):
	request = Request(url)
	request.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36')
	try:
		return urlopen(request).read().decode('utf-8')
	except:
		return False

def httpget2(url, refer):
	class MyHTTPRedirectHandler(HTTPRedirectHandler):
		url = ''
		def redirect_request(self, req, fp, code, msg, hdrs, newurl):
			self.url = newurl
			return HTTPRedirectHandler.redirect_request(self, req, fp, code, msg, hdrs, newurl)
	test = MyHTTPRedirectHandler()
	opener = build_opener(test)
	request = Request(url)
	request.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36')
	request.add_header('Referer', refer)
	try:
		opener.open(request)
		return test.url
	except:
		return None

def htmlparser(content):
	if sys.version_info >= (2, 7, 3) and sys.version_info < (3, 0):
		return BeautifulSoup(content, 'html.parser')
	if sys.version_info >= (3, 2) and sys.version_info < (4, 0):
		return BeautifulSoup(content, 'html.parser')
	return BeautifulSoup(content, 'html5lib')

def video(url):
	content = httpget(url)
	if not content:
		return {'code': 'localau 100'}
	items = []
	soup = htmlparser(content)
	p = soup.find('div', {'class': 'playerlist'})
	if p:
		suburl = p.find('a').attrs['href']
		url = urljoin(url, suburl)
		content = httpget(url)
		if not content:
			return {'code': 'localau 101'}
		soup = htmlparser(content)
		a = []
		for e in soup.find('div', {'class': 'play-nav2'}).find_all('em'):
			a.append(e.getText())
		i = 0
		for e1 in soup.find('div', {'class': 'playerlist2'}).find_all('ul'):
			for e2 in e1.find_all('a'):
				title = e2.getText()
				if len(a) > 1:
					title = a[i] + '_' + title
				items.append({'title': title, 'url': urljoin(url, e2.attrs['href'])})
			i += 1
	else:
		for e1 in soup.find('div', {'class': 'info-txt'}).find_all('div'):
			if 'class' in e1.attrs and e1.attrs['class'] == 'brief':
				break
			for e2 in e1.find_all('a'):
				items.append({'title': e2.getText(), 'url': urljoin(url, e2.attrs['href'])})
	return {'item': items}

def play(url):
	content = httpget(url)
	if not content:
		return {'code': 'localau 200'}
	soup = htmlparser(content)
	url2 = soup.find('iframe', {'id': 'main'}).attrs['src']
	url3 = re.search('/player/player\.php\?(.*)', url2)
	if url3:
		url3 = urljoin(url, url2)
		url2 = httpget2(url3, url)
	url3 = re.search('yunbo.html\?url=(.*)', url2)
	if url3:
		url3 = url3.group(1)
		return {'url': {'m3u8': url3}, 'header': {'Referer': url}}
	return {'code': 'localau 201'}

def sports(url):
	content = httpget(url)
	if not content:
		return {'code': 'localau 300'}
	items = []
	soup = htmlparser(content)
	for e1 in soup.find_all('li', {'class': 'gamelist'}):
		title = []
		for e2 in e1.find_all(['span', 'div']):
			if 'style' in e2.attrs and 'display:none;' in e2.attrs['style']:
				continue
			if 'style' in e2.attrs and 'text-align:center;' in e2.attrs['style']:
				continue
			t = e2.find(text = True).strip()
			if not t:
				continue
			title.append(t)
		for e2 in e1.find_all(['span', 'div']):
			if 'style' in e2.attrs and 'display:none;' in e2.attrs['style']:
				continue
			if 'style' not in e2.attrs or 'text-align:center;' not in e2.attrs['style']:
				continue
			t = e2.find(text = True).strip()
			if not t:
				continue
			title.append(t)
		title = ' '.join(title)
		suburl = e1.find('a').attrs['href']
		items.append({'title': title, 'url': urljoin(url, suburl)})
	return {'item': items}

def game(url):
	content = httpget(url)
	if not content:
		return {'code': 'localau 310'}
	items = []
	soup = htmlparser(content)
	e1 = soup.find('div', {'id': 'links'})
	if e1:
		for e2 in e1.find_all('a'):
			url = e2.attrs['href']
			if url[:31] == 'http://sports.localau.com/play/':
				items.append({'title': e2.getText(), 'url': url})
	return {'item': items}

def sport(url):
	content = httpget(url)
	if not content:
		return {'code': 'localau 320'}
	soup = htmlparser(content)
	p = soup.find('iframe', {'id': re.compile('main.*')})
	if not p:
		return {'code': 'localau 321'}
	if 'src' not in p.attrs:
		return {'code': 'localau 322'}
	url = urljoin(url, p.attrs['src'])
	id = re.search('play.html\?id=(.*)', url)
	if id:
		id = id.group(1)
		return {'url': {'m3u8': 'http://live.centerch.com/%s.m3u8' % id}}
	day = re.search('\?day=(.*)', url)
	if day:
		content = httpget(url)
		if not content:
			return {'code': 'localau 323'}
		url = re.search('playurl\s*=\s*"(.*?)"', content)
		if not url:
			return {'code': 'localau 324'}
		url = url.group(1)
		return {'url': {'m3u8': url}}
	return {'code': 'localau 325'}
